﻿Imports System.Windows.Media.Imaging
Partial Public Class Page
 Inherits UserControl

 Public Sub New()
  InitializeComponent()
 End Sub
 Private nImageAtLeft As Integer = 1, nCellAtLeft As Integer = 0

 Private tabCells() As Image
 Private tabImages() As Image
 Private ts() As String = {"Cezanne", "Delacroix", "Corot", "Millet", "Renoir", "Monet", "Courbet", "VanGogh"}
 Private countImages As Integer, countCells As Integer = 6
 Private bRtoL As Boolean = True ' Right to Left


 Private Sub LayoutRoot_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
  Try
   countImages = ts.Length
   tabImages = New Image(countImages - 1) {}
   For i As Integer = 0 To countImages - 1
    tabImages(i) = New Image()
    tabImages(i).Source = New BitmapImage(New Uri(ts(i) & "Mini.jpg", UriKind.Relative))
    tabImages(i).Tag = ts(i)
   Next i
   For i As Integer = 0 To countCells - 1
    Dim img As Image = CType(FindName("img" & i), Image)
    img.Source = New BitmapImage(New Uri(tabImages(i).Tag & "Mini.jpg", UriKind.Relative))
    img.Tag = tabImages(i).Tag
   Next i

   tabCells = New Image(countCells - 1) {} ' références à des éléments UI Image
   tabCells(0) = img0
   tabCells(1) = img1
   tabCells(2) = img2
   tabCells(3) = img3
   tabCells(4) = img4
   tabCells(5) = img5

   For i As Integer = 0 To countCells - 1
    AddHandler tabCells(i).MouseEnter, AddressOf Page_MouseEnter
    AddHandler tabCells(i).MouseLeave, AddressOf Page_MouseLeave
    AddHandler tabCells(i).MouseLeftButtonDown, AddressOf Page_MouseLeftButtonDown
   Next i
   stb.Begin()
  Catch exc As Exception
   tb.Text = exc.Message
  End Try
 End Sub

 Private Sub RightArrow_MouseEnter(ByVal sender As Object, ByVal e As MouseEventArgs)
  If bRtoL = True Then
   anim0.By = 110
   anim1.By = 110
   anim2.By = 110
   anim3.By = 110
   anim4.By = 110
   anim5.By = 110
   bRtoL = False
  End If
 End Sub

 Private Sub LeftArrow_MouseEnter(ByVal sender As Object, ByVal e As MouseEventArgs)
  If bRtoL = False Then
   anim0.By = -110
   anim1.By = -110
   anim2.By = -110
   anim3.By = -110
   anim4.By = -110
   anim5.By = -110
   bRtoL = True
  End If
 End Sub

 Private Sub Page_MouseEnter(ByVal sender As Object, ByVal e As MouseEventArgs)
  stb.Pause()
 End Sub

 Private Sub stb_Completed(ByVal sender As Object, ByVal e As EventArgs)
  If bRtoL Then
   ' la cellule à gauche est déplacée à la fin et contient une nouvelle image  
   Dim nextImageToBeLoaded As Integer = (nImageAtLeft + 5) Mod countImages
   tabCells(nCellAtLeft).Source = New BitmapImage(New Uri(tabImages(nextImageToBeLoaded).Tag & "Mini.jpg", UriKind.Relative))
   tabCells(nCellAtLeft).Tag = tabImages(nextImageToBeLoaded).Tag
   tabCells(nCellAtLeft).SetValue(Canvas.LeftProperty, CDbl(550))
   nImageAtLeft = (nImageAtLeft + 1) Mod countImages
   nCellAtLeft = (nCellAtLeft + 1) Mod countCells
   stb.Begin()
  End If
  If bRtoL = False Then
   '  the cell at end is pushed in front with a new image
   'INSTANT VB NOTE: Embedded comments are not maintained by Instant VB
   'ORIGINAL LINE: int nCellAtEnd = (nCellAtLeft + countCells/* - 1*/) % countCells;
   Dim nCellAtEnd As Integer = (nCellAtLeft + countCells) Mod countCells
   Dim nextImageToBeLoaded As Integer = (nImageAtLeft + countImages - 1) Mod countImages
   tabCells(nCellAtLeft).Source = New BitmapImage(New Uri(tabImages(nextImageToBeLoaded).Tag & "Mini.jpg", UriKind.Relative))
   tabCells(nCellAtEnd).SetValue(Canvas.LeftProperty, 0.0)
   tabCells(nCellAtLeft).Tag = tabImages(nextImageToBeLoaded).Tag
   nImageAtLeft = (nImageAtLeft + countImages - 1) Mod countImages
   nCellAtLeft = (nCellAtLeft + countCells - 1) Mod countCells
   stb.Begin()
  End If
 End Sub

 Private Sub Page_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
  Dim img As Image = CType(sender, Image)
  Dim s As String = img.Tag.ToString()
  tb.Text = s
  bigImage.Source = New BitmapImage(New Uri(s & ".jpg", UriKind.Relative))
  stbBig.Begin()
 End Sub

 Private Sub Page_MouseLeave(ByVal sender As Object, ByVal e As MouseEventArgs)
  stb.Resume()
 End Sub

End Class